import commands, { Command } from ".";
import { filterAsync } from "../util";

const cmdHelp: Command = {
  names: ["help", "cmds"],
  desc: "list out commands you have access to",
  checkPerm: async () => true,
  async handler(msg, { reply }) {
    const availCmds = await filterAsync(
      commands,
      async (cmd) => await cmd.checkPerm(msg)
    );

    let text = `// List of commands (${availCmds.length} count)\n`;

    for (let cmd of availCmds) {
      text += `${cmd.names[0]} `;
      if (cmd.names.length > 1) {
        text += `(aka: ${cmd.names.slice(1).join(", ")}) `;
      }
      text += `- ${cmd.desc}\n`;
    }

    text = "```\n" + text + "\n```";
    await reply(text);
  },
};

export default cmdHelp;
